
service daemon/hald {
    need = system/initial system/mountfs daemon/dbus
    daemon {
    
	# Make sure, there is no stale processes running.
	killall hald &> /dev/null
	killall -9 hald &> /dev/null
	
	# Clear pid file.
	rm /var/run/hal/pid &> /dev/null
	
	# We have to probe what version it is, they use diffrent arguments.
	/usr/sbin/hald --help 2>&1 | grep retain-privileges &> /dev/null
	if [ "$?" == "0" ]; then
	    exec /usr/sbin/hald --daemon=no --retain-privileges &> /dev/null
	else
	    exec /usr/sbin/hald --daemon=no --drop-privileges &> /dev/null
	fi
	echo "HALD failed to start!"
	exit 1
    }
}
