service system/initial {
    use = system/readahead plugin/readahead
    critical
start {

umask 022

# Cant se why /dev/null is needed before /dev is mounted.
#if [ ! -c /dev/null ] ; then
#	echo "Your root filesystem is missing /dev/null"
#	echo "You should really get this sorted out."
#fi

echo "Mounting proc at /proc ..."
mkdir -p /proc && mount -n -t proc none /proc || exit $? &

echo "Mounting sysfs at /sys ..."
mkdir -p /sys && mount -n -t sysfs none /sys || exit $? &

# need /proc mounted here.
wait 

# create /dev mount if not exist
grep "none /dev ramfs" /proc/self/mounts
if [ ! "$?" = "0" ]; then
    if [ -e /sbin/udevstart ]; then
	echo "Mounting ramfs at /dev ..."
	mkdir -p /dev && mount -n -t ramfs none /dev && mknod /dev/null c 1 3 -m 666 || exit $?

	echo "Configuring system to use udev ..."
	/sbin/udevstart
    
	# udevstart fails sometimes, retry until /dev/zero exists.
	while [ ! -e /dev/zero ]; do echo "waiting for /dev/zero to appere"; sleep 2; done

	# Not provided by sysfs but needed
	ln -snf /proc/self/fd /dev/fd &
	ln -snf fd/0 /dev/stdin &
	ln -snf fd/1 /dev/stdout &
	ln -snf fd/2 /dev/stderr &
	ln -snf /proc/kcore /dev/core &
	ln -snf /proc/asound/oss/sndstat /dev/sndstat &

	# Same thing as /dev/.devfsd
	touch /dev/.udev &
    fi
    wait
    echo "Mounting devpts at /dev/pts ..."
    mkdir -p /dev/pts && mount -n -t devpts -o gid=5,mode=0620 none /dev/pts || exit $? &

    echo "Mounting devshm at /dev/shm ..."
    mkdir -p /dev/shm && mount -n -t tmpfs none /dev/shm || exit $? &
    else
    echo "Ramfs found on /dev ..."
fi

# Setup hotplugging (if possible)
if [ -e /proc/sys/kernel/hotplug ]
then
    if   [ -x /sbin/udevsend ] ; then
	echo "  Setting /sbin/udevsend as hotplug agent ..."
	echo "/sbin/udevsend" > /proc/sys/kernel/hotplug

    elif [ -x /sbin/hotplug  ] ; then
	echo "  Using /sbin/hotplug as hotplug agent ..."
	echo "/sbin/hotplug" > /proc/sys/kernel/hotplug

    else
	echo "  Setting /sbin/udev as hotplug agent ..."
	echo "/sbin/udev" > /proc/sys/kernel/hotplug
    fi
fi

# Set the console loglevel to 1 for a cleaner boot
# the logger should anyhow dump the ring-0 buffer at start to the
# logs, and that with dmesg can be used to check for problems
/bin/dmesg -n 1 &

wait
#exit happily, or sulogin will be executed.
exit 0
}
}
