service system/static-modules {
	need = system/initial system/mountroot system/modules
start {
    
load_modules() {
	for x in `cat ${1}  | grep -v '^#' | grep '.'`
	do
	    MODULE=$(echo $x | cut -d' ' -f1)
	    MODARGS=$(echo $x | cut -d' ' -s -f2-)
	    echo "  Loading module \"${MODULE}\" ..."
	    modprobe -q ${MODULE} ${MODARGS} >/dev/null 2>&1
	done

	return 0
}


# GENTOO: Don't probe kernel version, initng, requires 2.6 anyway
if [ -e /etc/modules.autoload.d/kernel-2.6 ]; then
    load_modules /etc/modules.autoload.d/kernel-2.6
fi

if [ -e /etc/modules ]; then
    load_modules /etc/modules
fi

if [ -n "$(modprobe -l -t boot)" ]
then
	modprobe -a -t boot \*  >/dev/null 2>&1
fi

exit 0
}
}
# vim:ts=4
